/*******************************************************************************
 ADC2.c
 A/D-Converter Routine for all ADC Channels steer by Software                                 
  
  						PHYTEC Messtechnik GmbH, 2000
*******************************************************************************/


#include <REG167.H>                    	/* Register Set of 80C167 controller  */
#include <stdio.h>                     	/* Standard I/O functions             */

unsigned char Channel_Nr, Channel;
unsigned int Result;

/******************************************************************************/
/* main program                                                               */
/******************************************************************************/

void main (void)                       /* execution starts here               */
{
/* init serial0 port:                    				      */
  P3  |= 0x0400;                       /* set port 3.10 output latch (TXD)    */
  DP3 |= 0x0400;                       /* configure port 3.10 for output      */
                                       /* operation. ( TXD output)            */
  DP3 &= 0xF7FF;                       /* configure port 3.11 for input       */
                                       /* operation. ( RXD input)             */
  S0TIC = 0x80;                        /* set transmit interrupt flag         */
  S0RIC = 0x00;                        /* delete receive interrupt flag       */
  S0BG  = 0x40;                        /* set baudrate to 9600 baud           */
  S0CON = 0x8011;                      /* set serial mode                     */

  putchar(' ');                        /* send dummy-Byte for compatibility   */
/* init serial0 port:end               					      */

  printf ("\n                         Measure run                           \n");
  printf ("-----------------------------------------------------------------\n");
  printf ("| Channel Nr.                                                   |\n");
  printf ("| 0 | 1 | 2 | 3 | 4 | 5 | 6 | 7 | 8 | 9 |.0 |.1 |.2 |.3 |.4 |.5 |\n");


  while(1)
  {
     for(Channel_Nr = 0;Channel_Nr < 16;Channel_Nr++)
     { 
      ADCON = ADCON & 0x0000 | Channel_Nr;/* A/D-Converter: Channel = i, Single*/	
				       /* Channel Conversion		      */
      ADST = 1;		       	       /* Conversion start		      */

        while(ADBSY);	       	       /* wait of end of conversion	      */
   
      Result = ADDAT & 0x03FF;
      Channel = (ADDAT & 0xF000) / 4096;
      printf(" %x",Result);
     }
   printf("\r");	
  }
}

