/*******************************************************************************
 ADC3.c
 A/D-Converter scan all Channels in Auto-Scan Continuous Mode                                  

				               PHYTEC Messtechnik GmbH, 2000
*******************************************************************************/

#include <REG167.H>                    	/* Register Set of 80C167 controller  */
#include <stdio.h>                     	/* Standard I/O functions             */
#include "serio.h"

unsigned int Channel;
unsigned int  Result;

/* ----- A/D Conversion ready interrupt program ----------------------------- */
_interrupt (0x28) void ad_int (void) 
{
  Result = ADDAT;        		/* read result of conversion          */	
  Channel = Result & 0xF000;		/* read conversion channel            */
  printf(" %x",Result & 0x3FF); 	/* output result to PC without Channel 
  					   number			      */	
  if(Channel == 0) printf("\r");
}

/******************************************************************************/
/* main program                                                               */
/******************************************************************************/

void main (void)                       
{
  init_serio(9600);                   /* init serial0 port with 57600 baud   */
  putchar(' ');                        /* send dummy-Byte for compatibility   */


  printf ("\n                         Measure run                           \n");
  printf ("-----------------------------------------------------------------\n");
  printf ("| Channel Nr.                                                   |\n");
  printf ("|.5 |.4 |.3 |.2 |.1 |.0 | 9 | 8 | 7 | 6 | 5 | 4 | 3 | 2 | 1 | 0 |\n");

  ADCON = 0x023F;		       /* init AD-Converter in Auto Scan 
  				       	  Continuous Mode for all Channels    */
  ADCIC = 0x0062;		       /* init AD-Conversion ready interrupt  */ 
  IEN = 1;			       /* enable global interrupt	      */
  ADST  = 1;			       /* start A/D Conversion		      */

  while(1)
  {
    ;	/* here your program 	       					      */
	    /* stop Auto Scan Continuous Mode with ADST = 0;                  */
  }
}

