/*********************************************************************
  GPT1_1.c          												 
   Timer T3 from General Purpose Timer Block 1 as UP/DOWN Counter
   triggered from pin P3.6 (max. input frequency by fCPU = 20 MHz
   is 1.25 MHz).
			     	     PHYTEC Messtechnik GmbH, 2000
 *********************************************************************/

/* -------Including Files: ----------------------------------------- */
#include <REG167.H>          /* Register defin for C167              */
#include <STDIO.H>           /* Standard I/O functions               */
#include "serio.h"           /* Init serial interface ASC0           */

#define COUNT_END 20
 
_sfrbit P3_6  _atbit(P3,6);
_sfrbit DP3_6 _atbit(DP3,6);
/* ----- for Timer T2 ---------------------------------------------- 
_sfrbit P3_7  _atbit(P3,7);
_sfrbit DP3_7 _atbit(DP3,7);
   ----- for Timer T4 ---------------------------------------------- 
_sfrbit P3_5  _atbit(P3,5);
_sfrbit DP3_5 _atbit(DP3,5);
 ------------------------------------------------------------------- */
 
/* ------ main Program: -------------------------------------------- */
void main (void)
{  
  DP3_6 = 0;		     /* pin direction: input                 */
/* ----- for Timer T2 and T4 --------------------------------------- 
  P3_7  = 1;		     // use pin as alternate function        
  DP3_7 = 0;		     // pin direction: input                
  P3_7  = 1;		     // use pin as alternate function        
  DP3_7 = 0;		     // pin direction: input                
 ------------------------------------------------------------------- */
 
 init_serio(9600);          /* init serial interface ASC0: 8-bit data,
                                one stop bit, no parity, 57600 baud  */ 
 
  T3CON = 0x0009;	     // T3 as counter, triggered with rising 
  			     //	edge
//   or
//  T3CON = 0x000A;          // T3 as counter, triggered with falling
                             // edge
//   or
//  T3CON = 0x000B;          // T3 as counter, triggered with both 
                             // edges

  T3R   = 1;                 /* start Timer T3                       */


/* ----- for Timer T2 and T4 ----------------------------------------- 
  T2CON = 0x0009;	     // init Timer T2 as counter, rising edge
  T2R   = 1;                 // start Timer T2                       
  T4CON = 0x0009;	     // init Timer T4 as counter, rising edge
  T4R   = 1;                 // start Timer T4
 ------------------------------------------------------------------- */

   printf("\n");
   while (1)                 /* endless loop	                     */
   {

     /* here your program    		                             */

   	 printf("Counter = %u\r",T3);
	 if(T3 >= COUNT_END) T3UD = 1; /* Count Down                 */
	 if(T3 == 0)         T3UD = 0; /* Conut Up                   */

     /* here your program    		                             */
   } 
}

