/*********************************************************************
  GPT1_2.c          												 
   Timer T3 from General Purpose Timer Block 1 as Timer with variable
   input clock. BLINKY with delay time from Timer 3.
   
                            		 PHYTEC Messtechnik GmbH, 2000
 *********************************************************************/

/* -------Including Files: ----------------------------------------- */
#include <REG167.H>          /* Register defin for C167              */
#include "LED.h"
 
_sfrbit DT3OUT _atbit(DP3,3);
unsigned char T3I;

/* ------ main Program: -------------------------------------------- */
void main (void)
{
  LED_on;  		     /* defined in LED.h                     */
  T3OUT  = 1;		     /* use pin as alternate function        */
  DT3OUT = 1;		     /* pin direction: output                */
  
             /* ---------------------------------------------------- */
             /*                     Fcpu = 20 MHz                    */
             /* ---------------------------------------------------- */
             /* T3I |   Input   | Overflow  |  Output   |   Output   */
	     /* bin |   Clock   |  Period   | Frequency |   Period   */
             /* ---------------------------------------------------- */
//  T3I = 0; /* 000 | Fcpu/8    |  26.21 ms | 19.073 Hz |  52.428 ms */
//  T3I = 1; /* 001 | Fcpu/16   |  52.43 ms |  9.536 Hz | 104.857 ms */
//  T3I = 2; /* 010 | Fcpu/32   | 104.86 ms |  4.768 Hz | 209.715 ms */
//  T3I = 3; /* 011 | Fcpu/64   | 209.71 ms |  2.284 Hz | 419.430 ms */
    T3I = 4; /* 100 | Fcpu/128  | 419.43 ms |  1.192 Hz | 838.861 ms */
//  T3I = 5; /* 101 | Fcpu/256  | 838.86 ms |  0.596 Hz |   1.677 s  */
//  T3I = 6; /* 110 | Fcpu/512  |   1.677 s |  0.298 Hz |   3.355 s  */
//  T3I = 7; /* 111 | Fcpu/1024 |   3.355 s |  0.149 Hz |   6.710 s  */
             /* ---------------------------------------------------- */ 
             /*    Overflow Period  = 1/[Fcpu/(8*(2^T3I)*(2^16)]     */
	     /*    Output Frequency = Fcpu/[8*(2^T3I)*(2^16)*2]      */
	     /*    Output Period    = 1/{Fcpu/[8*(2^T3I)*(2^16)*2]}  */
	     /* ---------------------------------------------------- */

  T3CON = 0x0200 | T3I;	     /* T3 as timer with Fcpu/128 input: 
			     	=> interrupt request all 419.43 ms
			     	becaus of Otput Toggle Latch on pin
			     	P3.3 frequency = 1.129 Hz   	     */

  T3R   = 1;                 /* start Timer T3                       */


   while (1)                 /* endless loop	                     */
   {
     /* here your program    		                             */

     LED = T3OTL;
     /* here your program    		                             */
   } 
}

