/*********************************************************************
  GPT2_1.c          												 
   Timer T6 from General Purpose Timer Block 2 as UP/DOWN Counter
   triggered from pin P5.12 (max. input frequency by fCPU = 20 MHz
   is 2.5 MHz).
				       PHYTEC Messtechnik GmbH, 2000
 *********************************************************************/

/* -------Including Files: ----------------------------------------- */
#include <REG167.H>          /* Register defin for C167              */
#include <STDIO.H>           /* Standard I/O functions               */
#include "serio.h"           /* Init serial interface ASC0           */

#define COUNT_END 20
 
 
/* ------ main Program: -------------------------------------------- */
void main (void)
{  
/* The Port 5 is always input */
 
    init_serio(57600);       /* init serial interface ASC0: 8-bit data,
                                one stop bit, no parity, 57600 baud  */ 
 
    T6CON = 0x0009;	     // T6 as counter, triggered with rising 
  			     //	edge
//   or
//  T6CON = 0x000A;          // T6 as counter, triggered with falling
                             // edge
//   or
//  T6CON = 0x000B;          // T6 as counter, triggered with both 
                             // edges

    T6R   = 1;               /* start Timer T6                       */


/* ----- for Timer T5 ------------------------------------------------ 
  T5CON = 0x0009;	     // init Timer T5 as counter, rising edge
  T5R   = 1;                 // start Timer T5                       
 ------------------------------------------------------------------- */

   printf("\n");
   while (1)                 /* endless loop	                     */
   {
     /* here your program    		                             */

   	 printf("Counter = %u\r",T6);
	 if(T6 >= COUNT_END) T6UD = 1; /* Count Down                 */
	 if(T6 == 0)         T6UD = 0; /* Conut Up                   */

     /* here your program    		                             */
   } 
}

