/********************************************************************
  GPT2_5.c          												 
   Timer T6 from General Purpose Timer Block 2 as Timer with reload
   from CAPREL register by Overflow of T6 dependet from A/D value on 
   channel 0.

				     PHYTEC Messtechnik GmbH, 2000
 *********************************************************************/

/* -------Including Files: ----------------------------------------- */
#include <REG167.H>          /* Register defin for C167              */
#include "ADC.h"	     /* A/D- Converter function              */

_sfrbit DT6OUT  _atbit(DP3,1);

 
/* ------ main Program: -------------------------------------------- */
void main (void)
{

  
  T6OUT  = 1;                /* use alternative function of pin      */
  DT6OUT = 1;		     /* pin direction: output                */
 
 
  T6CON = 0x8200;	     /* T6 as timer with clock Fcpu/4, enable
			        Alternate Output Function, enable 
			        reload from register CAPREL          */

  T6 = CAPREL = 0xFB1D;      /* load start und reload value Fout = 
                                1.0 kHz at pin P3.1   	             */

  T6R   = 1;                 /* start Timer T6                       */


   while (1)                 /* endless loop	                     */
   {
     /* here your program    		                             */
     CAPREL = (ADC(0) << 6); /* load new reload value to CAPREL      */
   } 
}

