/********************************************************************
   GPT2_8.c         
                                                                    
   Multiply of frequency with two GPT2-Timer and CAPREL       
   The timer 5 works as timer with CPU-Takt/16, start value T5 = 0,
   count directions: UP.
   The timer 6 works as timer with CPU-Takt/4, start value = CAPREL,
   count directions: DOWN, enable Output Toggle Latch.
   Output frequency = CAPIN-input-frequency * 4                
   Through rising edge on P3.2/CAPIN is T5 in the CAPREL saved and        
   with 0000H loaded.               
   On each T6-Overflow is CAPREL to T6 loaded.          

                            	       PHYTEC Messtechnik GmbH, 2000
 *********************************************************************/

#include <REG167.H>         /* register define for C167              */
#include "PWM.h"            /* init PWM Unit for C167                */

_sfrbit P31  _atbit(P3,1);  /* define Bit name P31 for P3.1          */
_sfrbit DP31 _atbit(DP3,1); /* define Bit name DP31 for DP3.1        */

/* ----- main program: --------------------------------------------- */
void main ( )
{  
   PWM();		    /* start PWM unit for test signal        */

   /* The Pin P3.2/CAPIN is after Reset always input                 */
   P31  = 1;                /* enable pin P3.6 as aternative         */
   DP31 = 1;                /* function output for T6                */

   T5CON = 0xD002;          /* init timer 5 with clock = Fcpu/16,
   			       enable capture for CAPREL with rising
			       edge                                  */
   T5    = 0;               /* load stert value for Timer 5          */
   T6CON = 0x8280;          /* init timer 6 with clock = Fcpu/4, 
                               count DOWN, enable reload from  CAPREL*/

   T6R = T5R = 1;           /* start timer 5 und timer 6             */

   while (1)                /* endless loop                          */
   {
      ;   /* your program                                            */
   } 
}