/*********************************************************************
  PWM1.c for PHYTEC mM167          												 
                                                                 
  The PWM-Unit generate a PWM-Signal on PWM-Channel 1 Center Aligned
   PWM with constant frequecy (period) and puls width from 1/2 of 
   period.
  The PWM-Timer 1 work with CPU-Clock (20 MHz)                     
  The period register contain the value 40000:                     
      Frequency a PWM-Signal = 20 MHz / 2 * (40000-1) = 250 Hz    
      Output at Port pin P7.1/POUT1 High-aktive (pin B42).              
 
				    PHYTEC Messtechnik GmbH, 2000
 *********************************************************************/

/* -------Including Files: ----------------------------------------- */
#include <REG167.H>          /* Register defin for C167              */
_sfrbit DP71  _atbit(DP7,1); /* Bitname DP71 for DP7.1 define        */

/* ------ main Program: -------------------------------------------  */
void main (void)
{  
   DP71  = 1;                /* Define PWM-Output as Push-/Pull-
                                Output, Latch-contents after Reset 0 */
   PM1   = 1;                /* PWM-Channel 1 Center Aligned Mode    */
   PP1   = 40000;	     /* Load period register                 */
   PW1   = 20000;            /* Load puls width register             */
   PEN1  = 1;                /* P7.1/POUT1 release                   */
   PTR1  = 1;                /* Start of PWM-Timer 1                 */

   while (1)                 /* endless loop	                     */
   {
      			     /* your program			     */
   } 
}
/* -- End of program ----------------------------------------------- */
